﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_listview_display_subitem_icons
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Start with the last View (Details) selected.
            cboView.SelectedIndex = cboView.Items.Count - 1;

            // Make the column headers.
            lvwBooks.MakeColumnHeaders(
                "Title", 230, HorizontalAlignment.Left,
                "URL", 220, HorizontalAlignment.Left,
                "ISBN", 130, HorizontalAlignment.Left,
                "Picture", 230, HorizontalAlignment.Left,
                "Pages", 70, HorizontalAlignment.Right,
                "Year", 80, HorizontalAlignment.Right);

            // Add data rows.
            lvwBooks.AddRow("WPF 3d", "http://www.csharphelper.com/wpf3d.html", "978-1983905964", "http://www.csharphelper.com/wpf3d_350_429.jpg", "430", "2018");
            lvwBooks.AddRow("The C# Helper Top 100", "http://www.csharphelper.com/top100.htm", "978-1546886716", "http://www.csharphelper.com/top100_350_433.jpg", "380", "2017");
            lvwBooks.AddRow("Interview Puzzles Dissected", "http://www.csharphelper.com/puzzles.htm", "978-1539504887", "http://www.csharphelper.com/interview_puzzles_350_433.jpg", "300", "2016");
            lvwBooks.AddRow("C# 24-Hour Trainer, 2e", "http://tinyurl.com/n2a5797", "978-1-119-06566-1", "http://www.csharphelper.com/csharp24hr_2e_79x100.jpg", "600", "2015");
            lvwBooks.AddRow("Beginning Software Engineering", "http://tinyurl.com/pz7bavo", "978-1-118-96914-4", "http://tinyurl.com/y7zusrct", "480", "2015");
            lvwBooks.AddRow("Essential Algorithms", "http://tinyurl.com/y9uqajqv", "978-1-118-61210-1", "http://tinyurl.com/y84d2jgp", "624", "2013");
            lvwBooks.AddRow("Beginning Database Design Solutions", "http://www.vb-helper.com/db_design.htm", "978-0-470-38549-4", "http://www.vb-helper.com/db_design.jpg", "522", "2008");

            // Add icons to the sub-items.
            for (int r = 0; r < lvwBooks.Items.Count; r++)
            {
                // Set the main item's image index.
                lvwBooks.Items[r].ImageIndex = r;

                // Set the sub-item indices.
                for (int c = 1; c < lvwBooks.Columns.Count; c++)
                {
                    lvwBooks.AddIconToSubitem(r, c, 6 + c);
                }
            }

            // Initially display the sub-item icons if
            // the check box is checked.
            lvwBooks.ShowSubItemIcons(chkSubitemIcons.Checked);
        }

        // Toggle grid lines.
        private void chkGridLines_CheckedChanged(object sender, EventArgs e)
        {
            lvwBooks.GridLines = chkGridLines.Checked;
        }

        // Toggle sub-item icons.
        private void chkSubitemIcons_CheckedChanged(object sender, EventArgs e)
        {
            lvwBooks.ShowSubItemIcons(chkSubitemIcons.Checked);
        }

        // Change the ListView's view.
        private void cboView_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cboView.Text)
            {
                case "Large Icons":
                    lvwBooks.View = View.LargeIcon;
                    break;
                case "Small Icons":
                    lvwBooks.View = View.SmallIcon;
                    break;
                case "List":
                    lvwBooks.View = View.List;
                    break;
                case "Tile":
                    lvwBooks.View = View.Tile;
                    break;
                case "Details":
                    lvwBooks.View = View.Details;
                    break;
            }
        }
    }
}
